<span style="color: green" *ngIf="notification">{{notification}}</span>

<h2>Main form:</h2>
<form [formGroup]="mainForm" (ngSubmit)="onSubmit()">
  <label for="name">Name: </label>
  <input id="name" type="text" formControlName="name">
  <br/>

  <h2>Email (sub) form</h2>
  <form [formGroup]="emailForm" (ngSubmit)="onSubmitEmail()">
    <label for="email">Email: </label>
    <input id="email" type="email" formControlName="email" required>
    <button type="submit" [disabled]="!emailForm.valid">Add email</button>
  </form>
  <br/>

  <div formArrayName="emails">
    <h2>View list of emails ({{emails.length}})</h2>
    <div *ngFor="let email of emails.controls; let i=index">
      {{emails.at(i).value}} <button type="button" (click)="onDelete(i)">Delete</button>
    </div>
  </div>
  <br/>
  <button type="submit" [disabled]="!mainForm.valid">Submit</button>
</form>

<h2>Errors</h2>
<div *ngIf="mainForm.valid; then thenBlock; else elseBlock"></div>
<ng-template #thenBlock>
  <span style="color: green">There are no errors</span>
</ng-template>
<ng-template #elseBlock>
  <span style="color: red">There are errors!</span>
  <ul>
    <li>{{mainForm.errors['requireOne']}}</li>
  </ul>
</ng-template>
